#pragma once
#include <Adafruit_CircuitPlayground.h>
#include <stdint.h>

#define RAINBOW1 (RGB{0xff, 0x00, 0x00})
#define RAINBOW2 (RGB{0xff, 0x7f, 0x00})
#define RAINBOW3 (RGB{0xff, 0xff, 0x00})
#define RAINBOW4 (RGB{0x7f, 0xff, 0x00})
#define RAINBOW5 (RGB{0x00, 0xff, 0x00})
#define RAINBOW6 (RGB{0x00, 0xff, 0x7f})
#define RAINBOW7 (RGB{0x00, 0xff, 0xff})
#define RAINBOW8 (RGB{0x00, 0x7f, 0xff})
#define RAINBOW9 (RGB{0x00, 0x00, 0xff})
#define RAINBOW10 (RGB{0x7f, 0x00, 0xff})

#define RAINBOW_SIZE 10


class PixelManager {
public:
    /**
     * @brief Struct for the RGB
     *
     */
    struct RGB {
        uint8_t r;
        uint8_t g;
        uint8_t b;
    };

    /**
     * @brief Set all the pixels according to the rainbow index
     *
     * @param index the index of the rainbow
     */
    static void set_pixels_rainbow(int index) {
        RGB RAINBOW[RAINBOW_SIZE] = {RAINBOW1, RAINBOW2, RAINBOW3,
         RAINBOW4, RAINBOW5, RAINBOW6, RAINBOW7, RAINBOW8, RAINBOW9, RAINBOW10};

        for (int i = 0; i < 10; i++) {
            CircuitPlayground.setPixelColor(i,
                RAINBOW[(index + i) % RAINBOW_SIZE].r,
                RAINBOW[(index + i) % RAINBOW_SIZE].g,
                RAINBOW[(index + i) % RAINBOW_SIZE].b);
        }
    }
};
